package daoSample;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.sql.DataSource;

/**
 * JDBCoRŏif[^ɃANZXNX
 */
public class JdbcItemDao implements ItemDao {

	/** RlNV */
	private DataSource source;

	/**
	 * VJdbcItemDaõCX^X𐶐܂B
	 * @param source
	 */
	public JdbcItemDao(DataSource source) {
		this.source = source;
	}

	/**
	 * ȉo^܂B
	 * @param item
	 */
	public void insert(Item item) {
		PreparedStatement statement = null;
		Connection conn = null;
		try {
			StringBuffer sql = new StringBuffer();
			sql.append("insert into stock(");
			sql.append("  id, ");
			sql.append("  category, ");
			sql.append("  name, ");
			sql.append("  number, ");
			sql.append("  cost ");
			sql.append(") ");
			sql.append("values(?, ?, ?, ?, ?)");

			conn = source.getConnection();
			statement = conn.prepareStatement(sql.toString());
			
			int index = 1;
			statement.setInt(index++, item.getId());
			statement.setString(index++, item.getCategory());
			statement.setString(index++, item.getName());
			statement.setInt(index++, item.getNumber());
			statement.setInt(index++, item.getCost());
			
			statement.executeUpdate();
			commit(conn);
		} catch (SQLException e) {
			rollback(conn);
			throw new DataAccessException(e.getMessage(), e);
		} finally {
			close(statement);
			close(conn);
		}
	}

	/**
	 * ȉXV܂B
	 * @param item
	 */
	public void update(Item item) {
		PreparedStatement statement = null;
		Connection conn = null;
		try {
			StringBuffer sql = new StringBuffer();
			sql.append("update ");
			sql.append("  stock ");
			sql.append("set ");
			sql.append("  category=?, ");
			sql.append("  name=?, ");
			sql.append("  number=?, ");
			sql.append("  cost=?, ");
			sql.append("where ");
			sql.append("  id=? ");

			conn = source.getConnection();
			statement = conn.prepareStatement(sql.toString());
			
			int index = 1;
			statement.setString(index++, item.getCategory());
			statement.setString(index++, item.getName());
			statement.setInt(index++, item.getNumber());
			statement.setInt(index++, item.getCost());
			statement.setInt(index++, item.getId());
			
			statement.executeUpdate();
			commit(conn);
		} catch (SQLException e) {
			rollback(conn);
			throw new DataAccessException(e.getMessage(), e);
		} finally {
			close(statement);
			close(conn);
		}
	}

	/**
	 * ȉIDL[Ɍ܂B
	 * @param id
	 */
	public Item selectById(int id) {
		ResultSet rs = null;
		PreparedStatement statement = null;
		Connection conn = null;
		try {
			StringBuffer sql = new StringBuffer();
			sql.append("select ");
			sql.append("  id, ");
			sql.append("  category, ");
			sql.append("  name, ");
			sql.append("  number, ");
			sql.append("  cost ");
			sql.append("from ");
			sql.append("  stock ");
			sql.append("where ");
			sql.append("  id=? ");
	
			conn = source.getConnection();
			statement = conn.prepareStatement(sql.toString());
			
			int index = 1;
			statement.setInt(index++, id);
			
			rs = statement.executeQuery();
			Item item = new Item();
			if (rs.next()) {
				item.setId(rs.getInt("id"));
				item.setCategory(rs.getString("category"));
				item.setName(rs.getString("name"));
				item.setNumber(rs.getInt("number"));
				item.setCost(rs.getInt("cost"));
			}
			
			return item;

		} catch (SQLException e) {
			rollback(conn);
			throw new DataAccessException(e.getMessage(), e);
		} finally {
			close(rs);
			close(statement);
			close(conn);
		}
	}

	/**
	 * ȉJeSL[Ɍ܂B
	 * @param category
	 */
	public Item[] selectByCategory(String category) {
		ResultSet rs = null;
		PreparedStatement statement = null;
		Connection conn = null;
		try {
			StringBuffer sql = new StringBuffer();
			sql.append("select ");
			sql.append("  id, ");
			sql.append("  category, ");
			sql.append("  name, ");
			sql.append("  number, ");
			sql.append("  cost ");
			sql.append("from ");
			sql.append("  stock ");
			sql.append("where ");
			sql.append("  category=? ");
	
			conn = source.getConnection();
			statement = conn.prepareStatement(sql.toString());
			
			int index = 1;
			statement.setString(index++, category);
			
			rs = statement.executeQuery();
			List list = new ArrayList();
			while(rs.next()) {
				Item item = new Item();
				item.setId(rs.getInt("id"));
				item.setCategory(rs.getString("category"));
				item.setName(rs.getString("name"));
				item.setNumber(rs.getInt("number"));
				item.setCost(rs.getInt("cost"));
				list.add(item);
			}
			
			return (Item[]) list.toArray(new Item[list.size()]);

		} catch (SQLException e) {
			rollback(conn);
			throw new DataAccessException(e.getMessage(), e);
		} finally {
			close(rs);
			close(statement);
			close(conn);
		}
	}

	/**
	 * ȉIDL[ɍ폜܂B
	 * @param id
	 */
	public void delete(int id) {
		PreparedStatement statement = null;
		Connection conn = null;
		try {
			StringBuffer sql = new StringBuffer();
			sql.append("delete ");
			sql.append("from ");
			sql.append("  stock ");
			sql.append("where ");
			sql.append("  id=? ");

			conn = source.getConnection();
			statement = conn.prepareStatement(sql.toString());
			
			int index = 1;
			statement.setInt(index++, id);
			
			statement.executeUpdate();
			commit(conn);
			
		} catch (SQLException e) {
			rollback(conn);
			throw new DataAccessException(e.getMessage(), e);
		} finally {
			close(statement);
			close(conn);
		}
	}

	/**
	 * R~bg܂B
	 * @param conn
	 */
	private void commit(Connection conn) {
		if (conn != null) {
			try {
				conn.commit();
			} catch (SQLException e) {
				throw new DataAccessException(e.getMessage(), e);
			}
		}
	}

	/**
	 * [obN܂B
	 * @param conn
	 */
	private void rollback(Connection conn) {
		if (conn != null) {
			try {
				conn.rollback();
			} catch (SQLException e1) {
				throw new DataAccessException(e1.getMessage(), e1);
			}
		}
	}

	/**
	 * RlVN[Y܂B
	 * @param conn
	 */
	private void close(Connection conn) {
		if (conn != null) {
			try {
				conn.close();
			} catch (SQLException e) {
				throw new DataAccessException(e.getMessage(), e);
			}
		}
	}

	/**
	 * Xe[ggN[Y܂B
	 * @param statement
	 */
	private void close(PreparedStatement statement) {
		if (statement != null) {
			try {
				statement.close();
			} catch (SQLException e) {
				throw new DataAccessException(e.getMessage(), e);
			}
		}
	}

	/**
	 * ʃZbgN[Y܂B
	 * @param rs
	 */
	private void close(ResultSet rs) {
		if (rs != null) {
			try {
				rs.close();
			} catch (SQLException e) {
				throw new DataAccessException(e.getMessage(), e);
			}
		}
	}
}
