package singleton;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Map;
import java.util.HashMap;
import java.util.List;
import java.util.LinkedList;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class StaffListCache {

	private static Log log = LogFactory.getLog(StaffListCache.class);
	private static StaffListCache instance = new StaffListCache();
	private Map stafflistmap = new HashMap();
	private StaffContext context = new StaffContext(AnalysisStaffCompanyA.COMPANYCODE_A);

	private StaffListCache() {
	}

	public static StaffListCache getInstance() {

		if (instance == null) {
			instance = new StaffListCache();
		}

		return instance;
	}

	public List getStaffList(String filename) {

		List list = (List)stafflistmap.get(filename);

		if (list == null) {
			list = new LinkedList();
			FileReader freader;
			try {
				freader = new FileReader(filename + ".csv");
				BufferedReader breader = new BufferedReader(freader);

				String line;
				while((line = breader.readLine()) != null) {
					list.add(context.getStaff(line));
				}

				stafflistmap.put(filename, list);
				freader.close();
				System.out.println("t@C擾");
			} catch (IOException e) {
				log.error(e.getMessage(), e);
			}
		} else {
			System.out.println("LbV擾");
		}

		return list;
	}
}
