package singleton;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Map;
import java.util.HashMap;
import java.util.List;
import java.util.LinkedList;

public class StaffListCash {

	private static StaffListCash instance = new StaffListCash();
	private Map stafflistmap = new HashMap();
	private StaffContext context = new StaffContext(AnalysisStaffCompanyA.COMPANYCODE_A);

	private StaffListCash() {
	}

	public static StaffListCash getInstance() {

		if (instance == null) {
			instance = new StaffListCash();
		}

		return instance;
	}

	public List getStaffList(String filename) {

		List list = (List)stafflistmap.get(filename);

		if (list == null) {
			list = new LinkedList();
			FileReader freader;
			try {
				freader = new FileReader(filename + ".csv");
				BufferedReader breader = new BufferedReader(freader);

				String line;
				while((line = breader.readLine()) != null) {
					list.add(context.getStaff(line));
				}

				stafflistmap.put(filename, list);
				freader.close();
				System.out.println("t@C擾");
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else {
			System.out.println("LbV擾");
		}

		return list;
	}
}
